# PhingFilterReader

Extends \DataType

A PhingFilterReader is a wrapper class that encloses the className and configuration of a Configurable FilterReader.

This class handles the common description attribute and provides a default implementation for reference handling and checking for circular references that is appropriate for types that can not be nested inside elements of the same type (i.e. patternset but not path)

author | Yannick Lecaillez yl@seasonfive.com
version | $Id: 31c0eed7c2c8a83cd5055890b2034ae83089452e $
see |
package | phing.types

### Methods

## addParam

    addParam(\Parameter $param)

### Arguments

#### $param

`\Parameter`

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference() : \BuildException

inherited

### Response

`\BuildException`

## createClasspath

    createClasspath() : \Path

throws |

### Response

`\Path`

## createParam

    createParam()

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference( &$stk, \Project $p) : void

inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

throws |

### Arguments

#### $stk

``

#### $p

`\Project`

## Performs the check for circular references and returns the referenced object.

    getCheckedRef( $requiredClass,  $dataTypeName) : mixed

inherited

throws |

### Arguments

#### $requiredClass

``

#### $dataTypeName

``

### Response

`mixed`

## getClassName

    getClassName()

## getClasspath

    getClasspath()

## Return the description for the current data type.

    getDescription()

inherited

retujrn | string

## getParams

    getParams() : array

### Response

`array`

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Has the refid attribute of this element been set?

    isReference() : boolean

inherited

### Response

`boolean`

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed() : \BuildException

inherited

### Response

`\BuildException`

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

inherited

{@inheritdoc}

## setClassName

    setClassName( $className)

### Arguments

#### $className

``

## Set the classpath to load the FilterReader through (attribute).

    setClasspath(\Path $classpath)

throws |

### Arguments

#### $classpath

`\Path`

## setClasspathRef

    setClasspathRef(\Reference $r)

throws |

### Arguments

#### $r

`\Reference`

## Sets a description of the current data type. It will be useful in commenting what we are doing.

    setDescription(string $desc) : void

inherited

### Arguments

#### $desc

`string`

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Set the value of the refid attribute.

    setRefid(\Reference $r) : void

inherited

Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do they must call parent::setRefid()

### Arguments

#### $r

`\Reference`

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes() : \BuildException

inherited

### Response

`\BuildException`

### Properties

## className

    className :

### Type(s)

``

## parameters

    parameters :

### Type(s)

``

## classPath

    classPath :

### Type(s)

``

## The descriptin the user has set.

    description : string

inherited

var |

### Type(s)

`string`

## Value to the refid attribute.

    ref : \Reference

inherited

var |

### Type(s)

`\Reference`

## Are we sure we don't hold circular references?

    checked : boolean

inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

var |

### Type(s)

`boolean`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`